/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.6 Professional
Automatic Program Generator
© Copyright 1998-2005 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com
e-mail:office@hpinfotech.com

Project : 
Version : 
Date    : 17.11.2008
Author  : F4CG                            
Company : F4CG                            
Comments: 


Chip type           : ATmega16
Program type        : Application
Clock frequency     : 12,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega16.h>     

int PA,PocitadloZnaku; 
unsigned char baterie,M1I,M2I;  
unsigned char Enc1a,Enc1b,Enc1c,Enc1d, Enc2a,Enc2b,Enc2c,Enc2d; 
long int ENC1,ENC2; 
char Znak;

// I2C Bus functions
#asm
   .equ __i2c_port=0x1B ;PORTA
   .equ __sda_bit=6
   .equ __scl_bit=7
#endasm
#include <i2c.h>
#include <delay.h> 
#include <stdio.h>
void IICzapis(unsigned char adresa, unsigned char data)
{
  i2c_start();
  i2c_write(0xB0);
  delay_ms(2);
  i2c_write(adresa); 
  delay_ms(2);
  i2c_write(data);delay_ms(5);
  i2c_stop();
  delay_ms(3);
}              

unsigned char IICcteni(unsigned char adresa)
{ 
unsigned char Data;
  i2c_start();
  i2c_write(0xB0); 
delay_ms(5);
  i2c_write(adresa);
delay_ms(5);
  i2c_start();
  i2c_write(0xB1); 
delay_ms(5);
  Data=i2c_read(0);
  i2c_stop();
  return Data;                    
  
}

#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

// USART Receiver buffer
#define RX_BUFFER_SIZE 8
char rx_buffer[RX_BUFFER_SIZE];

#if RX_BUFFER_SIZE<256
unsigned char rx_wr_index,rx_rd_index,rx_counter;
#else
unsigned int rx_wr_index,rx_rd_index,rx_counter;
#endif

// This flag is set on USART Receiver buffer overflow
bit rx_buffer_overflow;

// USART Receiver interrupt service routine
interrupt [USART_RXC] void usart_rx_isr(void)
{
char status,data;
status=UCSRA;
data=UDR;
if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
   {
   rx_buffer[rx_wr_index]=data;
   if (++rx_wr_index == RX_BUFFER_SIZE) rx_wr_index=0;
   if (++rx_counter == RX_BUFFER_SIZE)
      {
      rx_counter=0;
      rx_buffer_overflow=1;
      };
      
   };
   
   if (PocitadloZnaku==0)
  {
   Znak=UDR;
   PocitadloZnaku++;
  }         
   
   
}

#ifndef _DEBUG_TERMINAL_IO_
// Get a character from the USART Receiver buffer
#define _ALTERNATE_GETCHAR_
#pragma used+
char getchar(void)
{
char data;
while (rx_counter==0);
data=rx_buffer[rx_rd_index];
if (++rx_rd_index == RX_BUFFER_SIZE) rx_rd_index=0;
#asm("cli")
--rx_counter;
#asm("sei")
return data;


}
#pragma used-
#endif

// USART Transmitter buffer
#define TX_BUFFER_SIZE 8
char tx_buffer[TX_BUFFER_SIZE];

#if TX_BUFFER_SIZE<256
unsigned char tx_wr_index,tx_rd_index,tx_counter;
#else
unsigned int tx_wr_index,tx_rd_index,tx_counter;
#endif

// USART Transmitter interrupt service routine
interrupt [USART_TXC] void usart_tx_isr(void)
{
if (tx_counter)
   {
   --tx_counter;
   UDR=tx_buffer[tx_rd_index];
   if (++tx_rd_index == TX_BUFFER_SIZE) tx_rd_index=0;
   };
}

#ifndef _DEBUG_TERMINAL_IO_
// Write a character to the USART Transmitter buffer
#define _ALTERNATE_PUTCHAR_
#pragma used+
void putchar(char c)
{
while (tx_counter == TX_BUFFER_SIZE);
#asm("cli")
if (tx_counter || ((UCSRA & DATA_REGISTER_EMPTY)==0))
   {
   tx_buffer[tx_wr_index]=c;
   if (++tx_wr_index == TX_BUFFER_SIZE) tx_wr_index=0;
   ++tx_counter;
   }
else
   UDR=c; 
   
#asm("sei")
}
#pragma used-
#endif

// Standard Input/Output functions
#include <stdio.h>

// Declare your global variables here

void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud rate: 9600
UCSRA=0x00;
UCSRB=0xD8;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x4D;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// I2C Bus initialization
i2c_init();      


//IICzapis(0,20);


// Global enable interrupts
#asm("sei") 

IICzapis(14,10);  //  nabehy motoru  1-pomalu 5-default 10-nejrychleji
delay_ms(20);
IICzapis(16,0x20);      // reset pocitadel enkoderu     
delay_ms(20);
IICzapis(15,2); 
delay_ms(20);
IICzapis(1,128); 
delay_ms(20);
IICzapis(0,128);
delay_ms(10);   
Znak=0; 
PocitadloZnaku=0;



while (1)
      {
        baterie=IICcteni(10); 
        
        Enc1a=IICcteni(2);
        Enc1b=IICcteni(3);
        Enc1c=IICcteni(4);
        Enc1d=IICcteni(5);   
        //ENC1=Enc1d+Enc1c*16^1+Enc1b*16^2+Enc1a*16^3;
        
        Enc2a=IICcteni(6);
        Enc2b=IICcteni(7);
        Enc2c=IICcteni(8);
        Enc2d=IICcteni(9); 
        
        M1I=IICcteni(11);
        M2I=IICcteni(12);
        
        
        
        printf("%d B:%03d E1:%03d%03d%03d%03d E2:%03d%03d%03d%03d I1:%03d I2:%03d %d \n %c ",PocitadloZnaku, baterie,Enc1a,Enc1b,Enc1c,Enc1d, Enc2a,Enc2b,Enc2c,Enc2d, M1I,M2I,Znak,13);      
       //  printf("PA %d, B:%03d E1:%0d E2:%03d%03d%03d%03d I1:%03d I2:%03d \n %c ",PINA,baterie,ENC1, Enc2a,Enc2b,Enc2c,Enc2d, M1I,M2I,13);      
       
      //if(PocitadloZnaku>0)
      
      Znak=getchar();
      { 
       PocitadloZnaku=0;
      
        if(Znak =='8')    //zpatky
        {
          IICzapis(0,128-5);
        }  
        if(Znak =='5')       //zastav nebo stop
        {
          IICzapis(0,128);
        } 
        if(Znak =='2')     // vpred
        {
          IICzapis(0,128+5);
        }   
        
        if(Znak ==52)
        {
          IICzapis(1,128+10);
        } 
        if(Znak ==53) //rovne nebo stop
        {
          IICzapis(1,128);
        }         
        if(Znak ==54)
        {
          IICzapis(1,128-10);
        }
      }  
      // Place your code here

      };
}
